"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// builtin
const fs_1 = require("fs");
const process_1 = __importDefault(require("process"));
// local
const index_js_1 = require("./index.js");
// listen
process_1.default.on('message', function (message) {
    // console.log('worker', message.id)
    const { id, action, path } = message;
    if (action === index_js_1.Action.readdir) {
        (0, fs_1.readdir)(path, function (error, files) {
            if (error)
                return process_1.default.send({
                    id,
                    action,
                    path,
                    error,
                });
            process_1.default.send({
                id,
                action,
                path,
                data: files,
            });
        });
    }
    else if (action === index_js_1.Action.stat) {
        (0, fs_1.stat)(path, function (error, stat) {
            if (error)
                return process_1.default.send({
                    id,
                    action,
                    path,
                    error,
                });
            process_1.default.send({
                id,
                action,
                path,
                data: Object.assign({ directory: stat.isDirectory() }, stat),
            });
        });
    }
    else {
        process_1.default.send({
            id,
            action,
            path,
            error: new Error('unknown action'),
        });
    }
});
